unit Setting;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Param, ShlObj, DataList;

type
  TSettingForm = class(TForm)
    Edit1: TEdit;
    UpDown1: TUpDown;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    GroupBox1: TGroupBox;
    Button6: TButton;
    Button7: TButton;
    Button4: TButton;
    Button5: TButton;
    GroupBox2: TGroupBox;
    Button8: TButton;
    GroupBox3: TGroupBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    GroupBox4: TGroupBox;
    ComboBox1: TComboBox;
    CheckBox9: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    DoneFont: Boolean;
    Check2: Boolean;
    Check3: Boolean;
  end;

var
  SettingForm: TSettingForm;

implementation

uses Frame;

{$R *.DFM}

procedure TSettingForm.FormShow(Sender: TObject);
var
  Key, Shift: Integer;
begin
  UpDown1.Position := FrameForm.DCount; // o^f[^̍ő區ڐ(128 ` 1024 * 16)
  UpDown2.Position := FrameForm.HCount; // Rs[f[^̍ő區ڐ(8 ` 1024)
  CheckBox1.Checked := FrameForm.Confirm; // o^f[^Rs[폜ꍇɊmF邩ǂ߂B
  if FrameForm.Parameter1['FormStyle'] = Integer(fsStayOnTop) then
    CheckBox2.Checked := True // ɎOɕ\B
  else
    CheckBox2.Checked := False;
  if FrameForm.Parameter1.VBools['Resident'] then
    CheckBox3.Checked := True // ^XNgCɏ풓B
  else
    CheckBox3.Checked := False;
  CheckBox4.Checked := FrameForm.AutoRecord; // Rs[邽тɃf[^Iɓo^Ăǂ߂B
  CheckBox9.Checked := FrameForm.RichEdit1.WordWrap; // ̑ł͉E[Ő܂Ԃĕ\邩ǂ߂B
  DoneFont := False;

  Check2 := CheckBox2.Checked;
  Check3 := CheckBox3.Checked;

  Key := FrameForm.HotKey and $0000FFFF;
  if Key = 0 then
    ComboBox1.ItemIndex := 0
  else if (Key >= VK_F1) and (Key <= VK_F12) then
    ComboBox1.ItemIndex := Key - VK_F1 + 27
  else
    ComboBox1.ItemIndex := Key - Ord('A') + 1;
  Shift := FrameForm.HotKey shr 16;
  if (Shift and MOD_CONTROL) <> 0 then CheckBox5.Checked := True;
  if (Shift and MOD_SHIFT) <> 0 then CheckBox6.Checked := True;
  if (Shift and MOD_ALT) <> 0 then CheckBox7.Checked := True;
  if (Shift and MOD_WIN) <> 0 then CheckBox8.Checked := True;
end;

procedure TSettingForm.Button2Click(Sender: TObject);
var
  Key, Shift: Integer;
  hk: Integer;
begin
  FrameForm.DCount := UpDown1.Position; // o^f[^̍ő區ڐ(128 ` 1024 * 16)
  FrameForm.Parameter1['DCount'] := FrameForm.DCount;

  FrameForm.HCount := UpDown2.Position; // Rs[f[^̍ő區ڐ(8 ` 1024)
  FrameForm.Parameter1['HCount'] := FrameForm.HCount;

  FrameForm.Confirm := CheckBox1.Checked; // o^f[^Rs[폜ꍇɊmF邩ǂ߂tO
  FrameForm.Parameter1.VBools['Confirm'] := FrameForm.Confirm;

  if CheckBox2.Checked then
    FrameForm.Parameter1['FormStyle'] := Integer(fsStayOnTop)
  else
    FrameForm.Parameter1['FormStyle'] := Integer(fsNormal);

  if CheckBox3.Checked then
    FrameForm.Parameter1.VBools['Resident'] := True
  else
    FrameForm.Parameter1.VBools['Resident'] := False;

  FrameForm.AutoRecord := CheckBox4.Checked; // Rs[邽тɃf[^Iɓo^Ăǂ߂tO

  FrameForm.RichEdit1.WordWrap := CheckBox9.Checked; // ̑ł͉E[Ő܂Ԃĕ\邩ǂ߂B

  FrameForm.Parameter1.VBools['AutoRecord'] := FrameForm.AutoRecord;

  if DoneFont then
  begin
    FrameForm.RichEdit1.Font := FrameForm.FontDialog1.Font;
    FrameForm.ListBox1.Font := FrameForm.FontDialog1.Font;
    FrameForm.ListBox2.Font := FrameForm.FontDialog1.Font;
    FrameForm.Parameter1.VStrings['Font.Name'] := FrameForm.FontDialog1.Font.Name;
    FrameForm.Parameter1['Font.Size'] := FrameForm.FontDialog1.Font.Size;
    FrameForm.Parameter1.VFontStyles['Font.Style'] := FrameForm.FontDialog1.Font.Style;
    FrameForm.Parameter1['Font.Color'] := FrameForm.FontDialog1.Font.Color;
  end;

  if Check3 <> CheckBox3.Checked then
  begin
    if CheckBox3.Checked then // ^XNgCɏ풓ꍇ
      FrameForm.Parameter1.CreateShortCut(CSIDL_STARTUP, 'ClipN')
    else
      FrameForm.Parameter1.DeleteShortCut(CSIDL_STARTUP, 'ClipN');
  end;

  if (Check2 <> CheckBox2.Checked) or (Check3 <> CheckBox3.Checked) then
  begin
    if FrameForm.Resident then
      ShowMessage(#13#10 + '̐ݒ́AUClipN풓' + #13#10 + #13#10 +
                           '̋NLƂȂ܂B' + #13#10)
    else
      ShowMessage(#13#10 + '̐ݒ́AUClipNI' + #13#10 + #13#10 +
                           '̋NLƂȂ܂B' + #13#10);
  end;

  { HotKeyC p̒l߂B}
  Key := ComboBox1.ItemIndex;
  if Key > 26 then
    Key := Key - 27 + VK_F1
  else if Key > 0 then // 'A' ` 'Z'
    Key := Key - 1 + Ord('A');
  Shift := 0;
  if CheckBox5.Checked then Shift := Shift or MOD_CONTROL;
  if CheckBox6.Checked then Shift := Shift or MOD_SHIFT;
  if CheckBox7.Checked then Shift := Shift or MOD_ALT;
  if CheckBox8.Checked then Shift := Shift or MOD_WIN;

  hk := Key or (Shift shl 16);

  if ((hk <> 0) and (((hk and $FFFF0000) = 0) or ((hk and $0000FFFF) = 0))) then
    ShowMessage(#13#10 + 'zbgL[̎w肪słB' + #13#10 + #13#10 +
                'L[ƈʃL[̂ꂩ̃L[' + #13#10 + #13#10 +
                'Ȃɂ鎖́Ao܂B' + #13#10)
  else if FrameForm.Resident then // ݁A^XNg[ɏ풓ĂƂ
  begin
    if FrameForm.HotKey <> hk then // HotKeyC ύXꂽƂ
    begin
      FrameForm.HotKey := hk;
      FrameForm.DeleteHotKey; // zbgL[̓o^
      FrameForm.AddHotKey; // zbgL[o^
    end;
  end
  else
    FrameForm.HotKey := hk;

  FrameForm.Parameter1.SaveToFile;
end;

procedure TSettingForm.Button1Click(Sender: TObject);
begin
  if FrameForm.FontDialog1.Execute then
    DoneFont := True;
end;

procedure TSettingForm.Button6Click(Sender: TObject);
var
  i: Integer;
  ao, err: Boolean;
  DL: TDataList;
begin
  OpenDialog1.Title := 'f[^t@Cf[^[h܂B';
  if OpenDialog1.Execute then
  begin
    ao := FrameForm.DataList1.AllowOverlapping;
    FrameForm.DataList1.AllowOverlapping := False;
    DL := TDataList.Create;
    try
      err := False;
      try // f[^t@C
        DL.LoadFromFile(OpenDialog1.FileName);
      except
        err := True;
      end;

      if err = False then
      begin
        FrameForm.DataList1.Assign(DL);
        FrameForm.ListBox1.Clear;
        FrameForm.DataList1.DataOption := True;
        for i := 0 to FrameForm.DataList1.Count - 1 do
          FrameForm.ListBox1.Items.Add(FrameForm.UntilLargeData(FrameForm.DataList1.TextItems[i]));
        FrameForm.DataList1.DataOption := False;
        FrameForm.ListBox1.TopIndex := 0;
        ShowMessage('t@C ' + #13#10 + #13#10 + OpenDialog1.FileName + #13#10 + #13#10 +
                    ' ' + IntToStr(FrameForm.DataList1.Count) + ' ̃f[^[h܂B');
      end
      else
        ShowMessage('f[^[ho܂łB');
    finally
      DL.Free;
      FrameForm.DataList1.AllowOverlapping := ao;
    end;
  end;
  OpenDialog1.Title := 't@CJ';
end;

procedure TSettingForm.Button7Click(Sender: TObject);
var
  msgr: Word;
  err: Boolean;
begin
  SaveDialog1.Title := '݂̃f[^t@Cɕۑ܂B';
  if SaveDialog1.Execute then
  begin
    if FileExists(SaveDialog1.FileName) then
      msgr := MessageDlg('t@C ' + #13#10 + #13#10 + SaveDialog1.FileName + #13#10 + #13#10 +
                         '́Ałɑ݂܂B㏑܂?',
                         mtConfirmation, [mbYes, mbNo], 0)
    else
      msgr := mrYes;

    if msgr = mrYes then
    begin
      err := False;
      try
        FrameForm.DataList1.SaveToFile(SaveDialog1.FileName);
      except
        err := True;
      end;
      if err = False
      then
        ShowMessage('݂̃f[^t@C ' + #13#10 + #13#10 + SaveDialog1.FileName + #13#10 + #13#10 +
                    'ɕۑ܂B')
      else
        ShowMessage('f[^ۑo܂łB');
    end;
  end;
  SaveDialog1.Title := 't@CJ';
end;

procedure TSettingForm.Button4Click(Sender: TObject);
var
  i, n: Integer;
  ao: Boolean;
begin
  OpenDialog1.Title := 't@C̃f[^vX܂B';
  if OpenDialog1.Execute then
  begin
    ao := FrameForm.DataList1.AllowOverlapping;
    FrameForm.DataList1.AllowOverlapping := False;
    try
      n := FrameForm.DataList1.PlusFile(OpenDialog1.FileName);
    except
      n := 0;
    end;
    if n > 0 then
    begin
      FrameForm.ListBox1.Clear;
      FrameForm.DataList1.DataOption := True;
      for i := 0 to FrameForm.DataList1.Count - 1 do
        FrameForm.ListBox1.Items.Add(FrameForm.UntilLargeData(FrameForm.DataList1.TextItems[i]));
      FrameForm.DataList1.DataOption := False;
      FrameForm.ListBox1.TopIndex := 0;
      ShowMessage('t@C ' + #13#10 + #13#10 + OpenDialog1.FileName + #13#10 + #13#10 +
                  'QƂ ' + IntToStr(n) + ' ̃f[^vX܂B');
    end
    else
      ShowMessage(IntToStr(n) + ' ̃f[^vX܂B');
    FrameForm.DataList1.AllowOverlapping := ao;
  end;
  OpenDialog1.Title := 't@CJ';
end;

procedure TSettingForm.Button5Click(Sender: TObject);
var
  i, n: Integer;
  ao: Boolean;
begin
  OpenDialog1.Title := 't@C̃f[^}CiX܂B';
  if OpenDialog1.Execute then
  begin
    ao := FrameForm.DataList1.AllowOverlapping;
    FrameForm.DataList1.AllowOverlapping := False;
    try
      n := FrameForm.DataList1.MinusFile(OpenDialog1.FileName);
    except
      n := 0;
    end;
    if n > 0 then
    begin
      FrameForm.ListBox1.Clear;
      FrameForm.DataList1.DataOption := True;
      for i := 0 to FrameForm.DataList1.Count - 1 do
        FrameForm.ListBox1.Items.Add(FrameForm.UntilLargeData(FrameForm.DataList1.TextItems[i]));
      FrameForm.DataList1.DataOption := False;
      FrameForm.ListBox1.TopIndex := 0;
      ShowMessage('t@C ' + #13#10 + #13#10 + OpenDialog1.FileName + #13#10 + #13#10 +
                  'QƂ ' + IntToStr(n) + ' ̃f[^}CiX܂B');
    end
    else
      ShowMessage(IntToStr(n) + ' ̃f[^}CiX܂B');
    FrameForm.DataList1.AllowOverlapping := ao;
  end;
  OpenDialog1.Title := 't@CJ';
end;

procedure TSettingForm.Button8Click(Sender: TObject);
begin
  ComboBox1.ItemIndex := 0;
  CheckBox5.Checked := False;
  CheckBox6.Checked := False;
  CheckBox7.Checked := False;
  CheckBox8.Checked := False;
end;

end.
