program ClipKun;

uses
  Windows,
  Messages,
  Forms,
  Frame in 'Frame.pas' {FrameForm},
  Setting in 'Setting.pas' {SettingForm},
  Option in 'Option.pas' {OPtionForm},
  Preview in 'Preview.pas' {PreviewForm};

const
  WM_ClipKun = WM_APP + $300;

{$R *.RES}

var
  MutexName: String;
  hMutex: THandle;
begin
  MutexName := 'ClipKun Copyright(C) 2015 seizo';
  hMutex:= OpenMutex(MUTEX_ALL_ACCESS, False, PChar(MutexName));
  if hMutex <> 0 then
  begin
    CloseHandle(hMutex);
    SendMessage(HWND_BROADCAST, WM_NULL, 0, WM_ClipKun);
  end
  else
  begin
    hMutex:= CreateMutex(Nil, False, PChar(MutexName));

    Application.Initialize;
    Application.CreateForm(TFrameForm, FrameForm);
  Application.CreateForm(TOPtionForm, OPtionForm);
  Application.CreateForm(TPreviewForm, PreviewForm);
  Application.Run;

    ReleaseMutex(hMutex);
  end;
end.
